/*********************************************************************
 * HY16F188 GMM
 * -------------------------------------------------------------------
 * Copyright 2013 HYCON
 * http://www.hycontek.com/
 *
 * Release 1.0.8
 *     2013/11/23
 **********************************************************************/
/*--------------------------------------------------------------------*/
/* Includes                                                            */
/*--------------------------------------------------------------------*/
#include "HY16F188.h"
#include "System.h"
#include "DrvGPIO.h"
#include "DrvCLOCK.h"
#include "DrvTimer.h"
#include "DrvADC.h"
#include "DrvPMU.h"
#include "HY2613.h"
//#include "seg7.h"
#include "DrvDAC.h"
#include "DrvOP.h"
#include "DrvFlash.h"
#include "DrvREG32.h"
#include "DrvI2C.h"
#include "DrvHWI2C.h"
#include "my define.h"
/*--------------------------------------------------------------------*/
/* Global CONSTANTS                                                   */
/*--------------------------------------------------------------------*/
//unsigned int DisplayBuffer[18];
long ADCbuffer,ADCData;//ADC data save buffer
char ADCdone=0;
unsigned int sample=10;
#define Disable 0
#define Enable  1
int k=0,mp=0,c=0,d=0,e=0,k1,k2,k3,dac_bit=0,dot=4;
long  ADtemp1=0,ADtemp11=0,ADtemp12=0,ADtemp2=0,ADtemp21=0;
float ADtemp5=0,ADtemp6=0,ADtemp7=0,ADtemp8=0;
unsigned int ADtemp9=0,LCD3=0;

/*--------------------------------------------------------------------*/
/* Function PROTOTYPES                                                */
/*--------------------------------------------------------------------*/
void LCD_TEST(void);
void ClearLCDframe(void);
void LCD_DATA_DISPLAY(unsigned int LcdBuffer);
void InitalADC(void);
void Delay(unsigned int num);
void InitalOPA(void);
void IO_Set01(void);
void PASS_Mode(void);
/*--------------------------------------------------------------------*/
/* MAIN  function                                                     */
/*--------------------------------------------------------------------*/
int main(void)
{

  InitalI2C();
  SYS_EnableGIE(7,0x3F);  // Enable GIE(Global Interrupt)

  Ini_Display();
  ClearLCDframe();
  Delay(1000);
  DisplayHYcon();

  int i=0;sample=25;
  InitalADC();InitalOPA();dac_04=0xff16;
  DrvGPIO_Open(E_PT2,0x03,E_IO_PullHigh);//PT2 pull high enable
  DrvDAC_Open(E_DAC_PVDDA,E_DAC_NVSSA,0x16);//DAC bit
  i=k=mp=1;e=0;sample=10;ADCbuffer=0;
  dac_bit=0x16;ADtemp1=80;dot=4;k1=k2=k3=0;

  while(1)
  {
    asm("NOP");
    PASS_Mode();
    asm("NOP");
  }
  asm("NOP");
  return 0;
  asm("NOP");
}
/*--------------------------------------------------------------------*/
/* PASS Mode R                                                        */
/*--------------------------------------------------------------------*/
void PASS_Mode(void)
{
  IO_Set01();
  //k1=S_Ohm;k2=0;k3=S9;dot=5;
  Delay(0x8000);
  if(ADCdone==1)
  {
   ADtemp5=(ADCData>>17);
   ADtemp5=ADtemp5+1;//370//28//95
   if(ADtemp5<0){ADtemp5=ADtemp5*(-1);}
   ADCdone=0;
   ADtemp6=ADtemp5/147;
   ADtemp7=20000/ADtemp6;
   if(ADtemp7>50000){ADtemp7=0;}
   ADtemp9=ADtemp7;
   if(ADtemp9>990)
   {LCD3=1;}else{LCD3=0;}
   LCD_DATA_DISPLAY(ADtemp9);
  }
  Delay(0x10);
  LCD_DATA_DISPLAY(ADtemp7);
  Delay(0x10);
}


/*---------------------------------------------------------------------------*/
/* Hardware Communication Interrupt                                          */
/* UART/SPI/I2C Interrupt Service Routines                                   */
/*---------------------------------------------------------------------------*/
void HW0_ISR(void)
{
  unsigned char I2C_Status;

  if(DrvI2C_ReadIntFlag()==E_DRVI2C_INT)  // Get I2C Interrupt Flag
  {
    I2C_Status=DrvI2C_GetStatusFlag();  // Get I2C Status Flag
    switch(I2C_Status)
    {
      case 0x90: //MACTFlag+RWFlag
          { /* START has been transmitted */
            DrvI2C_WriteData(I2C_TARGET);  //Send Slave Address & R/W Bit
            DrvI2C_Ctrl(0,0,0,0);  // Clear all I2C flag
            break;
          };
      case 0x84: //MACTFlag+ACKFlag
          { /* Slave A + W has been transmitted. ACK has been received. */
            DrvI2C_WriteData(Sendbuf[DataTxIndex++]);  //Send Data to Slave
            DrvI2C_Ctrl(0,0,0,0);  // Clear all I2C flag
            break;
          };
      case 0x80: //MACTFlag
          { /* Slave A + W has been transmitted. ACK has been received. */
            DrvI2C_WriteData(Sendbuf[DataTxIndex++]);  //Send Data to Slave
            DrvI2C_Ctrl(0,0,0,0);  // Clear all I2C flag
            break;
          };
      case 0x30:
          {
            DrvI2C_Ctrl(0,0,0,0);  // Clear all I2C flag
            EndFlag=1;
            break;
          };
      case 0x8C: // MACTFlag+DFFlag+ACKFlag
          { /* DATA has been transmitted and ACK has been received */
            if(DataTxIndex<DataTxLen)
            {
              DrvI2C_WriteData(Sendbuf[DataTxIndex++]);  //Send Data to Slave
              DrvI2C_Ctrl(0,0,0,0);  // Clear all I2C flag
            }
            else
            {
              if(I2C_RW == WRITE)
              {
                DrvI2C_Ctrl(0,1,0,0);  // I2C as master sends STOP signal
                EndFlag=1;
              }
              else if(I2C_RW == READ)
                DrvI2C_Ctrl(1,0,0,0);  // I2C as master sends START signal
              DataTxIndex=0;
            }
            break;
          };
      case 0x88: //MACTFlag+DFFlag
          { /* DATA has been transmitted and NACK has been received */
            DrvI2C_Ctrl(0,1,0,0);  // I2C as master sends STOP signal
            DataTxIndex=0;
            EndFlag=1;
            break;
          };
      case 0xB0:
          { /* A repeated START has been transmitted. */
            DrvI2C_WriteData(I2C_TARGET | READ);  //Send Slave Address & R/W Bit
            DrvI2C_Ctrl(0,0,0,0);  // Clear all I2C flag
            break;
          }
      case 0x94: //MACTFlag+RWFlag
          { /* Slave A + R has been transmitted. ACK has been received. */
            DrvI2C_Ctrl(0,0,0,1);  // Set ACK bit
            break;
          };
      case 0x9C: //MACTFlag+RWFlag+DFFlag+ACKFlag
          { /* Data byte has been received. ACK has been transmitted. */
            if(DataRxLen>DataRxIndex)
            {
              Recbuf[DataRxIndex++]=DrvI2C_ReadData();
              DrvI2C_Ctrl(0,0,0,0);  // Clear all I2C flag
            }
            else
            {
              Recbuf[DataRxIndex++]=DrvI2C_ReadData();
              DrvI2C_Ctrl(0,1,0,0);  // I2C as master sends STOP signal
              EndFlag=1;
            }
            break;
          };
      case 0x98: //MACTFlag+RWFlag+DFFlag
          { /* Data byte has been received. NACK has been transmitted. */
            DrvI2C_Ctrl(0,1,0,0);  // I2C as master sends STOP signal
            EndFlag=1;
            break;
          };
      default:
          {
            DrvI2C_Ctrl(0,0,0,0);  // Clear all I2C flag
            EndFlag=1;
            break;
          };
    }
    DrvI2C_ClearEIRQ();
    DrvI2C_ClearIntFlag(2); // Clear I2C Interrupt Flag(I2CIF)
    SYS_EnableGIE(7,0x3F);       // Enable GIE(Global Interrupt)
  }
  if(DrvI2C_ReadIntFlag()==E_DRVI2C_ERROR_INT)  //Get I2C Error Interrupt Flag
  {
    EndFlag=1;
    DrvI2C_ClearIRQ();
    DrvI2C_ClearIntFlag(2); // Clear I2C Interrupt Flag(I2CEIF)
    DrvI2C_Ctrl(0,1,0,0);   // I2C as master sends STOP signal
    SYS_EnableGIE(7,0x3F);       // Enable GIE(Global Interrupt)
  }
}










/*--------------------------------------------------------------------*/
/* ADC Interrupt Service Routines                                     */
/*--------------------------------------------------------------------*/
void HW2_ISR(void)
{
  DrvADC_ClearIntFlag();
  while(--sample==0)
  {
   ADCdone=1;sample=4;
   ADCData=DrvADC_GetConversionData();
  }
}
/*--------------------------------------------------------------------*/
/* PT1 Interrupt Service Routines                                     */
/*--------------------------------------------------------------------*/
void HW4_ISR(void)
{
  DrvGPIO_ClearIntFlag(E_PT1,0x40);         //Clear PT1 interrupt flag
  DrvGPIO_Open(E_PT1,0x00,E_IO_IntEnable);  //PT1.6 interrupt enable
}
/*--------------------------------------------------------------------*/
/* Software Delay Subroutines                                         */
/*--------------------------------------------------------------------*/
void Delay(unsigned int num)
{
  volatile unsigned int d;
  for(d=0;d<=num;d++);asm("NOP");
}
/*--------------------------------------------------------------------*/
/* ADC Initialization Subroutines                                     */
/*--------------------------------------------------------------------*/
void InitalADC(void)
{
  //Set ADC input pin
  DrvADC_SetADCInputChannel(ADC_Input_AIO2,ADC_Input_AIO3);
  //Set the ADC positive/negative input voltage source.
  DrvADC_InputSwitch(OPEN);
  //ADC signal input (positive and negative) short(VISHR) control.
  DrvADC_RefInputShort(OPEN);
  //Set the ADC reference input
  //(positive and negative) short(VRSHR) control.

  DrvADC_Gain(ADC_PGA_Disable,ADC_PGA_Disable);
  //Input signal gain for modulator.
  DrvADC_DCoffset(0);
  //DC offset input voltage selection (VREF=REFP-REFN)
  DrvADC_RefVoltage(VDDA,0);//Set the ADC reference voltage.
  DrvADC_FullRefRange(1);
  //Set the ADC full reference range select.
                            //0: Full reference range input
                            //1: 1/2 reference range input
  DrvADC_OSR(1);            //1 : OSR=16384 0 : OSR=32768
  DrvADC_CombFilter(Enable);//Enable OSR
  DrvADC_ClkEnable(0,1);
  //Setting ADC CLOCK ADCK=HS_CK/6 & Rising edge is high

  //Set VDDA voltage
  DrvPMU_VDDA_Voltage(E_VDDA2_4);
  DrvPMU_VDDA_LDO_Ctrl(E_LDO);
  DrvPMU_BandgapEnable();
  DrvPMU_REFO_Enable();
  DrvPMU_AnalogGround(Enable);//ADC analog ground source selection.
  //1 : Enable buffer and use internal source(need to work with ADC)
  DrvPMU_LDO_LowPower(Enable);//VDD LDO with low power control.
                              //0 : Normal;1 : Low power
  Delay(0x1000);
  //Set ADC interrupt
  DrvADC_EnableInt();
  DrvADC_ClearIntFlag();
  DrvADC_Enable();
}
/*--------------------------------------------------------------------*/
/* OPA Initialization Subroutines                                     */
/*--------------------------------------------------------------------*/
void InitalOPA(void)
{
  DrvPMU_VDDA_LDO_Ctrl(E_LDO);
  DrvPMU_VDDA_Voltage(E_VDDA2_4);
  //DrvOP_PInput(0x06);//DAC--AIO4
  DrvOP_PInput(0x04);//DAC--AIO4
  DrvDAC_Enable();
  DrvDAC_EnableOutput();
  //DrvDAC_Open(E_DAC_VDDA,E_DAC_VSSA,0x16);//0x35(0.4949V)
  DrvDAC_Open(E_DAC_PVDDA,E_DAC_NVSSA,0x16);//DAC bit
  dac_04=0xff16;
  DrvOP_Open();
  DrvOP_NInput(0x02);
  //OPA negative reference input selection AIO5 0x0
  DrvOP_OPOoutEnable();
}
/*--------------------------------------------------------------------*/
/* Software IO Set Subroutines                                        */
/*--------------------------------------------------------------------*/
void IO_Set01(void)
{
  DrvGPIO_Open(E_PT1,0xc0,E_IO_INPUT);   //set PT1 input
  DrvGPIO_Open(E_PT1,0x00,E_IO_OUTPUT);  //set PT1 output
  DrvGPIO_Open(E_PT1,0xc0,E_IO_PullHigh);//PT1 pull high enable
  DrvGPIO_Open(E_PT2,0xfc,E_IO_INPUT);   //set PT2 input
  DrvGPIO_Open(E_PT2,0xfc,E_IO_PullHigh);//PT2 pull high enable
  DrvGPIO_Open(E_PT3,0x21,E_IO_INPUT);   //set PT3 input
  DrvGPIO_Open(E_PT3,0x21,E_IO_PullHigh);//PT3 pull high enable
  DrvGPIO_Open(E_PT4,0x01,E_IO_INPUT);   //set PT4.0 input
  DrvGPIO_Open(E_PT4,0x01,E_IO_PullHigh);//PT4.0 pull high enable
}
/*--------------------------------------------------------------------*/
/* End Of File                                                        */
/*--------------------------------------------------------------------*/

/*--------------------------------------------------------------------*/
/* LCD RAM Data                                                       */
/*--------------------------------------------------------------------*/







